From oracle-l-bounce@freelists.org  Thu Mar  3 17:36:32 2005
Return-Path: <oracle-l-bounce@freelists.org>
Received: from air891.startdedicated.com (root@localhost)
 by orafaq.com (8.12.10/8.12.10) with ESMTP id j23NaWNO021779
 for <oracle-l@orafaq.com>; Thu, 3 Mar 2005 17:36:32 -0600
X-ClientAddr: 206.53.239.180
Received: from turing.freelists.org (freelists-180.iquest.net [206.53.239.180])
 by air891.startdedicated.com (8.12.10/8.12.10) with ESMTP id j23NaVem021773
 for <oracle-l@orafaq.com>; Thu, 3 Mar 2005 17:36:31 -0600
Received: from localhost (localhost [127.0.0.1])
 by turing.freelists.org (Avenir Technologies Mail Multiplex) with ESMTP id 9889C7D5FB;
 Thu,  3 Mar 2005 17:35:04 -0500 (EST)
Received: from turing.freelists.org ([127.0.0.1])
 by localhost (turing [127.0.0.1]) (amavisd-new, port 10024)
 with ESMTP id 09296-06; Thu, 3 Mar 2005 17:35:04 -0500 (EST)
Received: from turing (localhost [127.0.0.1])
 by turing.freelists.org (Avenir Technologies Mail Multiplex) with ESMTP id CA4EB7D8B1;
 Thu,  3 Mar 2005 17:35:03 -0500 (EST)
X-MimeOLE: Produced By Microsoft Exchange V6.0.6603.0
content-class: urn:content-classes:message
MIME-Version: 1.0
Content-type: text/plain; charset=us-ascii
Content-Transfer-Encoding: 8bit
Subject: RE: Anyway to optimize the optimizer
Date: Thu, 3 Mar 2005 17:33:19 -0500
Message-ID: <42BBD772AC30EA428B057864E203C999013C78F3@MSGBOSCLF2WIN.DMN1.FMR.COM>
X-MS-Has-Attach: 
X-MS-TNEF-Correlator: 
Thread-Topic: Anyway to optimize the optimizer
Thread-Index: AcUgQGjGwsJQo/BlSYi1qRsuvD5TIAAAF2VA
From: "Khedr, Waleed" <Waleed.Khedr@FMR.COM>
To: "jaromir nemec" <jaromir@db-nemec.com>, <oracle-l@freelists.org>
X-OriginalArrivalTime: 03 Mar 2005 22:33:19.0786 (UTC) FILETIME=[002D50A0:01C52041]
X-archive-position: 16934
X-ecartis-version: Ecartis v1.0.0
Sender: oracle-l-bounce@freelists.org
Errors-To: oracle-l-bounce@freelists.org
X-original-sender: Waleed.Khedr@FMR.COM
Precedence: normal
Reply-To: Waleed.Khedr@FMR.COM
X-list: oracle-l
X-Virus-Scanned: by amavisd-new-20030616-p9 (Debian) at avenirtech.net
X-Spam-Checker-Version: SpamAssassin 2.60 (1.212-2003-09-23-exp) on 
 air891.startdedicated.com
X-Spam-Status: No, hits=0.1 required=5.0 tests=AWL,LINES_OF_YELLING,
 LINES_OF_YELLING_2 autolearn=no version=2.60
X-Spam-Level: 

I thought about the partitioned view, but it will be ugly plus Oracle is
not planning to continue to support partitioned views.

Thanks

Waleed

-----Original Message-----
From: jaromir nemec [mailto:jaromir@db-nemec.com]=20
Sent: Thursday, March 03, 2005 5:28 PM
To: Khedr, Waleed; oracle-l@freelists.org
Subject: Re: Anyway to optimize the optimizer


Hi Waleed,



> Oracle does not substitute the value of C2 in the expression.



this could be achieved with two nested views using an expression e.g.
(c2 -=20
10) in the inner view and referencing this new column in query of the
outer.=20
But this is apparently not the desired solution.



I'd see a possible solution of this problem in a combination of
partitioned=20
views and partitioned tables (Jonathan mentioned it in his book, if I
recall=20
it correctly).



Something like this:

create or replace view v3

as

select c1,c2,c3

from test_p_v

where c2 >=3D 210 and c2 <=3D 309 and c1 >=3D 200

union all

select c1,c2,c3

from test_p_v

where c2 between 110 and 209 and c1 between 100 and 209

union all

select c1,c2,c3

from test_p_v

where c2 < 110 and c1 <=3D 99

;

So each UNION ALL subquery access at most 2 partitions. Note that this
is=20
only simplified solution to demonstrate the principle.



select * from v3

where c2 =3D 150;

Explaining  this simple query you get following execution plan
(10.1.0.2.0):

------------------------------------------------------------------------
-------------------------------

| Id  | Operation                  | Name     | Rows  | Bytes | Cost
(%CPU)|=20
Time     | Pstart| Pstop |

------------------------------------------------------------------------
-------------------------------

|   0 | SELECT STATEMENT           |          |   483 | 14490 |   342
(21)|=20
00:00:01 |       |       |

|   1 |  VIEW                      | V3       |   483 | 14490 |   342
(21)|=20
00:00:01 |       |       |

|   2 |   UNION-ALL PARTITION      |          |       |       |
|=20
|       |       |

|*  3 |    FILTER                  |          |       |       |
|=20
|       |       |

|   4 |     PARTITION RANGE SINGLE |          |     1 |    27 |  7622
(6)|=20
00:00:07 |     3 |     3 |

|*  5 |      TABLE ACCESS FULL     | TEST_P_V |     1 |    27 |  7622
(6)|=20
00:00:07 |     3 |     3 |

|   6 |    PARTITION RANGE ITERATOR|          |    60 |  1740 | 18148
(21)|=20
00:00:17 |     2 |     3 |

|*  7 |     TABLE ACCESS FULL      | TEST_P_V |    60 |  1740 | 18148
(21)|=20
00:00:17 |     2 |     3 |

|*  8 |    FILTER                  |          |       |       |
|=20
|       |       |

|   9 |     PARTITION RANGE SINGLE |          |     1 |    26 |  7193
(6)|=20
00:00:07 |     1 |     1 |

|* 10 |      TABLE ACCESS FULL     | TEST_P_V |     1 |    26 |  7193
(6)|=20
00:00:07 |     1 |     1 |

------------------------------------------------------------------------
-------------------------------





Predicate Information (identified by operation id):

---------------------------------------------------



   3 - filter(210<=3D150)

   5 - filter("C2"=3D150 AND "C2">=3D210 AND "C2"<=3D309)

   7 - filter("C2"=3D150 AND "C2">=3D110 AND "C2"<=3D209 AND =
"C1"<=3D209)

   8 - filter(110>150)

  10 - filter("C2"=3D150 AND "C2"<110 AND "C1"<=3D99)



A good question is if the obviously false filter  (e.g. 210<=3D150) does =

prohibit the underlying  table access. Some simple tests shows that this
is=20
OK and at most one union branch is executed if a equi-predicate on c2 is

defined. See below.

You may wont to verify some more complex queries on this view, usage of
bind=20
variables etc.



HTH



Jaromir D.B. Nemec

http://www.db-nemec.com



---- some test --

1) c2 out of range - instance responce



  1  select count(*) from v3

  2* where c2 =3D 550

SQL> /



Elapsed: 00:00:00.01



2) test partition pruning, only the 1st partition should be accessed --
>=20
OK, consistent gets corresponds to blocks of the partition



  1  select count(*) from v3

  2* where c2 =3D 109

SQL> /



Elapsed: 00:00:04.32





Statistics

----------------------------------------------------------

          8  recursive calls

          0  db block gets

      18778  consistent gets

      18758  physical reads

          0  redo size

        392  bytes sent via SQL*Net to client

        512  bytes received via SQL*Net from client

          2  SQL*Net roundtrips to/from client

          0  sorts (memory)

          0  sorts (disk)

          1  rows processed



SQL> set autotrace off

SQL> select partition_name,

  2  blocks

  3  from user_tab_partitions  a

  4  where

  5  table_name =3D upper('test_p_v');



PARTITION_NAME                     BLOCKS

------------------------------ ----------

P1                                  18765

P2                                  19785

P3                                  19913



Elapsed: 00:00:03.34

----- Original Message -----=20
From: "Khedr, Waleed" <Waleed.Khedr@FMR.COM>
To: "jaromir nemec" <jaromir@db-nemec.com>; <oracle-l@freelists.org>
Sent: Thursday, March 03, 2005 3:37 AM
Subject: RE: Anyway to optimize the optimizer



--
http://www.freelists.org/webpage/oracle-l

